/*
 * Copyright (c) 2005-2007 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.ui.editors.reflective;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ReflectiveItemProviderAdapterFactory;

/**
 * Specific item provider adapter factory for the reflective editor.
 * 
 * @author www.obeo.fr
 * 
 */
public class AcceleoReflectiveItemProviderAdapterFactory extends ReflectiveItemProviderAdapterFactory {

	/**
	 * Reflective editor.
	 */
	protected AcceleoReflectiveEditor reflectiveEditor;

	/**
	 * Contructor.
	 * 
	 * @param reflectiveEditor
	 *            is the reflective editor
	 */
	public AcceleoReflectiveItemProviderAdapterFactory(AcceleoReflectiveEditor reflectiveEditor) {
		this.reflectiveEditor = reflectiveEditor;
		reflectiveItemProviderAdapter = createReflectiveItemProvider();
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemPropertySource.class);
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(ITableItemLabelProvider.class);
	}

	/**
	 * Creates the specific item provider for the reflective editor.
	 * 
	 * @return the item provider
	 */
	protected AcceleoReflectiveItemProvider createReflectiveItemProvider() {
		return new AcceleoReflectiveItemProvider(this);
	}

	/**
	 * @return reflective editor
	 */
	public AcceleoReflectiveEditor getReflectiveEditor() {
		return reflectiveEditor;
	}

}
