/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.state_machines.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CallEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.ChangeEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CompositeState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Event;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.FinalState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Guard;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Pseudostate;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SignalEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SimpleState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateVertex;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StubState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SynchState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.TimeEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Transition;
import fr.obeo.acceleo.uml14.foundation.core.Element;
import fr.obeo.acceleo.uml14.foundation.core.ModelElement;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * 
 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage
 * @generated
 */
public class State_machinesSwitch {
	/**
	 * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static State_machinesPackage modelPackage;

	/**
	 * Creates an instance of the switch. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public State_machinesSwitch() {
		if (modelPackage == null) {
			modelPackage = State_machinesPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one
	 * returns a non null result; it yields that result. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one
	 * returns a non null result; it yields that result. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		} else {
			List eSuperTypes = theEClass.getESuperTypes();
			return eSuperTypes.isEmpty() ? defaultCase(theEObject) : doSwitch((EClass) eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one
	 * returns a non null result; it yields that result. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
		case State_machinesPackage.STATE_MACHINE: {
			StateMachine stateMachine = (StateMachine) theEObject;
			Object result = caseStateMachine(stateMachine);
			if (result == null)
				result = caseModelElement(stateMachine);
			if (result == null)
				result = caseElement(stateMachine);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.EVENT: {
			Event event = (Event) theEObject;
			Object result = caseEvent(event);
			if (result == null)
				result = caseModelElement(event);
			if (result == null)
				result = caseElement(event);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.STATE_VERTEX: {
			StateVertex stateVertex = (StateVertex) theEObject;
			Object result = caseStateVertex(stateVertex);
			if (result == null)
				result = caseModelElement(stateVertex);
			if (result == null)
				result = caseElement(stateVertex);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.STATE: {
			State state = (State) theEObject;
			Object result = caseState(state);
			if (result == null)
				result = caseStateVertex(state);
			if (result == null)
				result = caseModelElement(state);
			if (result == null)
				result = caseElement(state);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.TIME_EVENT: {
			TimeEvent timeEvent = (TimeEvent) theEObject;
			Object result = caseTimeEvent(timeEvent);
			if (result == null)
				result = caseEvent(timeEvent);
			if (result == null)
				result = caseModelElement(timeEvent);
			if (result == null)
				result = caseElement(timeEvent);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.CALL_EVENT: {
			CallEvent callEvent = (CallEvent) theEObject;
			Object result = caseCallEvent(callEvent);
			if (result == null)
				result = caseEvent(callEvent);
			if (result == null)
				result = caseModelElement(callEvent);
			if (result == null)
				result = caseElement(callEvent);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.SIGNAL_EVENT: {
			SignalEvent signalEvent = (SignalEvent) theEObject;
			Object result = caseSignalEvent(signalEvent);
			if (result == null)
				result = caseEvent(signalEvent);
			if (result == null)
				result = caseModelElement(signalEvent);
			if (result == null)
				result = caseElement(signalEvent);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.TRANSITION: {
			Transition transition = (Transition) theEObject;
			Object result = caseTransition(transition);
			if (result == null)
				result = caseModelElement(transition);
			if (result == null)
				result = caseElement(transition);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.COMPOSITE_STATE: {
			CompositeState compositeState = (CompositeState) theEObject;
			Object result = caseCompositeState(compositeState);
			if (result == null)
				result = caseState(compositeState);
			if (result == null)
				result = caseStateVertex(compositeState);
			if (result == null)
				result = caseModelElement(compositeState);
			if (result == null)
				result = caseElement(compositeState);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.CHANGE_EVENT: {
			ChangeEvent changeEvent = (ChangeEvent) theEObject;
			Object result = caseChangeEvent(changeEvent);
			if (result == null)
				result = caseEvent(changeEvent);
			if (result == null)
				result = caseModelElement(changeEvent);
			if (result == null)
				result = caseElement(changeEvent);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.GUARD: {
			Guard guard = (Guard) theEObject;
			Object result = caseGuard(guard);
			if (result == null)
				result = caseModelElement(guard);
			if (result == null)
				result = caseElement(guard);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.PSEUDOSTATE: {
			Pseudostate pseudostate = (Pseudostate) theEObject;
			Object result = casePseudostate(pseudostate);
			if (result == null)
				result = caseStateVertex(pseudostate);
			if (result == null)
				result = caseModelElement(pseudostate);
			if (result == null)
				result = caseElement(pseudostate);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.SIMPLE_STATE: {
			SimpleState simpleState = (SimpleState) theEObject;
			Object result = caseSimpleState(simpleState);
			if (result == null)
				result = caseState(simpleState);
			if (result == null)
				result = caseStateVertex(simpleState);
			if (result == null)
				result = caseModelElement(simpleState);
			if (result == null)
				result = caseElement(simpleState);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.SUBMACHINE_STATE: {
			SubmachineState submachineState = (SubmachineState) theEObject;
			Object result = caseSubmachineState(submachineState);
			if (result == null)
				result = caseCompositeState(submachineState);
			if (result == null)
				result = caseState(submachineState);
			if (result == null)
				result = caseStateVertex(submachineState);
			if (result == null)
				result = caseModelElement(submachineState);
			if (result == null)
				result = caseElement(submachineState);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.SYNCH_STATE: {
			SynchState synchState = (SynchState) theEObject;
			Object result = caseSynchState(synchState);
			if (result == null)
				result = caseStateVertex(synchState);
			if (result == null)
				result = caseModelElement(synchState);
			if (result == null)
				result = caseElement(synchState);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.STUB_STATE: {
			StubState stubState = (StubState) theEObject;
			Object result = caseStubState(stubState);
			if (result == null)
				result = caseStateVertex(stubState);
			if (result == null)
				result = caseModelElement(stubState);
			if (result == null)
				result = caseElement(stubState);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case State_machinesPackage.FINAL_STATE: {
			FinalState finalState = (FinalState) theEObject;
			Object result = caseFinalState(finalState);
			if (result == null)
				result = caseState(finalState);
			if (result == null)
				result = caseStateVertex(finalState);
			if (result == null)
				result = caseModelElement(finalState);
			if (result == null)
				result = caseElement(finalState);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>State Machine</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>State Machine</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStateMachine(StateMachine object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Event</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseEvent(Event object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>State Vertex</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>State Vertex</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStateVertex(StateVertex object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>State</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>State</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseState(State object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Time Event</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Time Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTimeEvent(TimeEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Call Event</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Call Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCallEvent(CallEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Signal Event</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Signal Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSignalEvent(SignalEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Transition</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Transition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTransition(Transition object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Composite State</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Composite State</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCompositeState(CompositeState object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Change Event</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Change Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseChangeEvent(ChangeEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Guard</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Guard</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGuard(Guard object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Pseudostate</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Pseudostate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePseudostate(Pseudostate object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Simple State</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Simple State</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSimpleState(SimpleState object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Submachine State</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Submachine State</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSubmachineState(SubmachineState object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Synch State</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Synch State</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSynchState(SynchState object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Stub State</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Stub State</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStubState(StubState object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Final State</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Final State</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseFinalState(FinalState object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseElement(Element object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Model Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Model Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseModelElement(ModelElement object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
	 * non-null result will terminate the switch, but this is the last case
	 * anyway. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return null;
	}

} // State_machinesSwitch
